package com.tofly.water.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.water.entity.DeviceBusiness;
import com.tofly.water.entity.dto.DeviceBusinessDto;

import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;

/**
 * 设备档案和外部主键关联(DeviceBusiness)表服务接口
 *
 * @author HaiQiu
 * @since 2022-11-30 15:36:47
 */
public interface DeviceBusinessService extends IService<DeviceBusiness> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    DeviceBusiness get(Serializable id);

    /**
     * 新增
     *
     * @param deviceBusinessDto 实体
     */
    void insert(DeviceBusinessDto deviceBusinessDto);

    /**
     * 修改
     *
     * @param deviceBusinessDto 实体
     */
    void edit(DeviceBusinessDto deviceBusinessDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page           分页
     * @param deviceBusiness 查询wrapper
     * @return 数据集合
     */
    Page<DeviceBusiness> pageList(Page page, DeviceBusiness deviceBusiness);

    /**
     * 数据导出
     *
     * @param page           分页
     * @param deviceBusiness 查询模型
     * @param isAll          是否导出全部数据，true是，false否（默认否）
     */
    void export(Page page, DeviceBusiness deviceBusiness, boolean isAll);

    /**
     * 查询所有数据
     *
     * @param deviceBusiness 查询条件
     * @return 查询所有数据
     */
    List<DeviceBusiness> allList(DeviceBusiness deviceBusiness);

    public void saveBusiness(Long busId,String tableName);

    public boolean removeBusiness(List<Long> busIds,String tableName);
}

